-# zshrc/85_git_prompt
+# zshrc/60_vcsprompt
#
# Make git information available to the prompt
#
# Copyright © 1994–2008 martin f. krafft <madduck@madduck.net>
# Released under the terms of the Artistic Licence 2.0
#
-# Source repository: http://git.madduck.net/v/etc/zsh.git
+# Source repository: git://git.madduck.net/etc/zsh.git
#
# Shamelessly based on http://glandium.org/blog/?p=170
#
__git_get_reporoot()
{
# return the full path to the root of the current git repository
- local relroot
- relroot="$(git rev-parse --show-cdup 2>/dev/null)" || return 1
- if [ -n "$relroot" ]; then
- readlink -f "$relroot"
- else
- echo $PWD
- fi
+ [ -d "$GIT_DIR" ] && echo "$GIT_DIR" && return 0
+ realpath -s "$PWD/$(git rev-parse --show-cdup)"
}
__git_get_branch()
{
# return the name of the git branch we're on
- local ref
- ref=$(git symbolic-ref -q HEAD 2>/dev/null \
- || git-name-rev --name-only HEAD 2>/dev/null) || return 1
+ local ref gitdir
+ gitdir="$(git rev-parse --git-dir)"
+ ref=$(git --git-dir="$gitdir" symbolic-ref -q HEAD 2>/dev/null \
+ || git --git-dir="$gitdir" name-rev --name-only HEAD 2>/dev/null) || return 1
echo "${ref#refs/heads/}"
}
+__git_print_preprompt()
+{
+ [ "$(git config --get core.bare)" = false ] || return
+
+ local output
+ output=(${(f):-"$(git diff --stat --relative 2>/dev/null)"})
+ if [[ ${#output} -gt 1 ]]; then
+ echo changes on filesystem:
+ print "${${(F)output[1,-2]}//\.\.\./…}"
+ fi
+ output=(${(f):-"$(git diff --cached --stat --relative 2>/dev/null)"})
+ if [[ ${#output} -gt 1 ]]; then
+ echo cached/staged changes:
+ print "${${(F)output[1,-2]}//\.\.\./…}"
+ fi
+}
+
__hg_get_reporoot()
{
hg root
local dir
while true; do
[ -d ${dir}.git ] && echo git && break
+ [ -d "$GIT_DIR" ] && echo git && break
[ -d ${dir}.bzr ] && echo bzr && break
[ -d ${dir}.hg ] && echo hg && break
[ "$(readlink -f ${dir:-.})" = / ] && echo NONE && break
# shortcut: if there are no arguments, return a default prompt
if [ -z "${1:-}" ]; then
- pwdnamed="%${_PROMPT_PATH_MAXLEN}<..<%~%<<"
- pwdnamed="${(%)pwdnamed}"
+ pwdnamed="${(%):-%${_PROMPT_PATH_MAXLEN}<…<%~%<<}"
echo "$pwdnamed"
return
fi
# replace named directories in the PWD, we need thi for the proper component
# count later
- local pwdnamed="%~"
- pwdnamed="${(%)pwdnamed}"
+ local pwdnamed
+ pwdnamed="${(%):-%~}"
# store paths in arrays for component count calculation
typeset -la apwd apwdnamed areporoot
precomps=$(($#apwdnamed - $postcomps))
local postfix
- if (( $postcomps > 0 )); then
- postfix="%${postcomps}~"
- postfix="${(%)postfix}"
- fi
+ (( $postcomps > 0 )) && postfix="${(%):-%${postcomps}~}"
# we don't want the prompt to get too long, so keep the total prompt length
# under $_PROMPT_PATH_MAXLEN (25), but ensure that the prefix is not shorter
prelen=$((${_PROMPT_PATH_MAXLEN:-25} - $#branch - $#postfix))
minlen=${_PROMPT_PATH_MINLEN:-10}
(( $prelen < $minlen )) && prelen=$minlen
- prefix="%${prelen}<..<%-${precomps}~%<<"
- prefix="${(%)prefix}"
+ prefix="${(%):-%${prelen}<…<%-${precomps}~%<<}"
- echo "$prefix" "$branch" "$postfix"
+ echo "'$prefix'" "'$branch'" "'$postfix'"
}
__vcs_set_prompt_variables()
{ error "could not determine git repository root"; return 1 }
branch="$(__git_get_branch)" ||
{ error "could not determine git branch"; return 1 }
+ if [ -n "$VCSH_REPO_NAME" ]; then
+ # if vcsh is used to get a subshell, then the repo root is the home
+ # directory, but we want to indicate the vcsh context too:
+ eval set -- $(__vcs_get_prompt_path_components "$HOME" "$branch")
+ set -- "vcsh:$VCSH_REPO_NAME" "$2" "$3"
+ else
+ eval set -- $(__vcs_get_prompt_path_components "$reporoot" "$branch")
+ if [ -d "$GIT_DIR" ]; then
+ # poor man's replace until I find out how to do named dirs properly
+ # here:
+ local _D="${GIT_DIR/$HOME/~}"
+ set -- "$_D" "$2" "${${1#$_D}%/}"
+ fi
+ fi
;;
hg)
reporoot="$(__hg_get_reporoot)" ||
{ error "could not determine hg repository root"; return 1 }
branch="$(__hg_get_branch)" ||
{ error "could not determine hg branch"; return 1 }
+ eval set -- $(__vcs_get_prompt_path_components "$reporoot" "$branch")
;;
bzr)
reporoot="$(__bzr_get_reporoot)" ||
{ error "could not determine bzr repository root"; return 1 }
branch="$(__bzr_get_branch)" ||
{ error "could not determine bzr branch"; return 1 }
+ eval set -- $(__vcs_get_prompt_path_components "$reporoot" "$branch")
;;
*)
case "$repotype" in
NONE) :;;
*) warn "$repotype repositories not (yet) supported in the prompt";;
esac
- local p="%${MAXLEN}<..<%~%<<"
+ local p="%${MAXLEN}<…<%~%<<"
#TODO find a better way so we don't have to nuke $psvar, but since the
# %(nv.true.false) check for prompts checks element count, not
# content, that's all we get for now
return
esac
- set -- $(__vcs_get_prompt_path_components "$reporoot" "$branch")
- psvar[1]="$1"
- psvar[2]="$2"
- psvar[3]="$3"
+ psvar[1,3]=($1 $2 $3)
+}
+
+__vcs_print_preprompt()
+{
+ local reporoot
+ repotype="${1:-$(__vcs_get_repo_type)}"
+
+ case "$repotype" in
+ git)
+ __git_print_preprompt
+ ;;
+ esac
}
if ! is_root; then
}
chpwd_functions+=_update_vcs_prompt_vars
+ _print_preprompt() {
+ [[ $? -eq 0 ]] && __vcs_print_preprompt
+ }
+ precmd_functions+=_print_preprompt
+
# call it once
_update_vcs_prompt_vars
fi